﻿Version=6.80
NumberOfForms=0
NumberOfObjects=0
Sub designer
end sub
@EndOfDesignText@
Sub Globals
  Dim ary1(20) As string
	Dim ary2(20) As string
	Dim ary3(20) As string
	Dim lvArray(20) As string
End Sub

Public Sub getToday(parm)
  If parm="yyyy-mm-dd" OR parm="yyyy" Then 
	  DateFormat (parm) 
	Else 
		DateFormat ("yyyymmdd")
	End If
	Return Date(Now)
End Sub

Public Sub tbl_MakeColumns(oo,fields,widths,dlm)
  Control(oo,table).Clear
	ary1() = StrSplit(fields, dlm)
	ary2() = StrSplit(widths, dlm)
	cnt=ArrayLen(ary1())-1
	cnt2=ArrayLen(ary2())-1
  For i=0 To cnt
	  If i>=cnt2 Then wdth=30 Else wdth=ary2(i)
    Control(oo,table).AddCol(cString, ary1(i),wdth, False)
	Next
End Sub

Public Sub tbl_Commands(what,oo)
  r=Control(oo,table).rowCount
	If r=0 Then Return -1 
	ptr=Control(oo,table).SelectedRow
	If ptr=-1 Then Return
	Select what
		Case "BACK": 	
			ptr=ptr-1
      If ptr<0 Then ptr=r-1
    Case "NEXT": 	
			ptr=ptr+1
      If ptr>=r Then ptr=0
    Case "DEL": 	
			Control(oo,table).RemoveRow(ptr): r=r-1
			If r>1 Then			  
				If ptr>0 Then ptr=ptr-1
			Else
				Return
		 End If 
    End Select
		If r>0 Then 
		  Control(oo,table).SelectCell(  Control(oo,table).ColName(0) , ptr)
		End If
End Sub

Public Sub tbl_Add_Updt(cmd,oo,data,dlm)
	ary1() = StrSplit(data, dlm)
  cnt=ArrayLen(ary1())-1

	If cmd="ADD" Then
	  Control(oo,table).AddRow("")	
		row=Control(oo,table).RowCount-1
  Else
		row=Control(oo,table).SelectedRow
	End If
	
  If row <> -1 Then
		For i = 0 To cnt-1
			Control(oo,table).Cell( Control(oo,table).ColName(i),row) = ary1(i)
		Next
	End If

End Sub

Public Sub tbl_GetRow(oo,row,dlm)
	st=""
	If Control(oo,table).rowCount<1 OR Control(oo,table).colCount<1 Then Return st
  For i = 0 To Control(oo,table).colCount - 1 
	  st=st & dlm & Control(oo,table).Cell( Control(oo,table).ColName(i),row) 
  Next
	Return ut.Mid(st,1,-1) 
End Sub

Public Sub TokenGet(tknLst,nt)
  ntSt="<" & nt & ">": ntEn="</" & nt & ">": n=StrIndexOf(tknLst,ntSt,0)
  If n=-1 Then Return ""
  n1=n+StrLength(ntSt): n2=StrIndexOf(tknLst,ntEn,n1): n2=n2-n1
  Return Mid(tknLst,n1,n2)
End Sub

Public Sub RepeatChar(char,num)
  st=""
  For i=1 To num
	  st=st & char
	Next
	Return st
End Sub

Public Sub Right(st,n)
 sL=StrLength(st)
 If sL<1 Then Return ""
 a=sL-n
 If a<=0 Then Return st Else Return SubString(st,a,n)
End Sub

Public Sub Left(st,n)
 sL=StrLength(st)
 If sL<1 Then Return ""
 If n<=0 OR n>sL Then n=sL  
 Return SubString(st,0,n)
End Sub

Public Sub Mid(st,a,n)
 sL=StrLength(st)
 If sL<1 Then Return ""
 If n<0 OR n>=sL Then z=sL Else z=n
 n=sL-a
 If z>n Then z=n
 Return SubString(st,a,z)
End Sub

Public Sub Trim(strg)
  Return RTrim(LTrim(strg))
End Sub

Public Sub LTrim(strg)
	Do While strg<>"" AND StrAt(strg,0)=" " 
	  strg=SubString(strg,1,StrLength(strg)-1)
	Loop
  Return strg
End Sub

Public Sub RTrim(strg)
	Do While strg<>"" AND StrAt(strg,StrLength(strg)-1)=" "
  	strg=SubString(strg,0,StrLength(strg)-1)
	Loop
  Return strg
End Sub

'supports both combo and listbox but compiler requires they exist
'if you have listbox just uncomment 2 listbox lines
Public Sub PutListBox(oo,str,dlm)
  ary2() = StrSplit(str, dlm)
	typ=ControlType(oo) 
	If typ="ComboBox" Then
	  Control(oo, ComboBox).clear
		Control(oo, ComboBox).text=""
		Control(oo, ComboBox).SelectedIndex=-1
	Else
		'Control(oo, listbox).clear
	End If	
	If str="" Then Return
	For i=0 To ArrayLen(ary2())-1
		If typ="ComboBox" Then
		  Control(oo, ComboBox).Add(ary2(i)) 
		Else
		  'Control(oo, ListBox).Add(ary2(i))
		End If
	Next	
End Sub 

Public Sub DataCheck(val,chk,msg)
  a=val: rc=""
  Select StrToLower(chk)
  Case "numeric","real","integer":
    a = ut.Strip(a, "-$,.()")
    If IsNumber(a)=False Then rc="is not Numeric"
  Case "date","cy-m-d","cy-m":
    a=ut.Strip(a, "-/")
    n=StrLength(a)
    If n<>8 AND n<>6 Then
      rc="has invalid Date Format"
    Else
      n=Int(ut.mid(a,4,2))
      If n<1 OR n>12 Then
        rc="has invalid Month"
      Else If StrLength(a)=8 Then
        m=n: d=31
        If m=2 Then
          y=Int(ut.mid(a,0,4))
          If y Mod 4 = 0 AND y Mod 100 <> 0 OR y Mod 400=0 Then d=29 Else d=28
        Else If m=4 OR m=6 OR m=9 OR m=11 Then
           d=30
        End If
        n=Int(ut.mid(a,6,2))
        If n<1 OR n>d Then rc="has invalid Day of the Month"
			  If StrToLower(chk)= "cy-m" Then rc="day not permitted"
      End If
    End If
  End Select

  If rc <> "" Then rc = "ERROR: " & msg & " " &  rc
  Return rc
End Sub


Public Sub Strip(st, chars)
  len=StrLength(st)
	newst=""
	For i=0 To len-1
	  n=StrIndexOf(chars, StrAt(st,i), 0)
		If n = -1 Then newst=newst & StrAt(st,i)
  Next
  Return newst
End Sub

Public Sub doFormat(oldtot,totfmt,totfmt2,FormatLetter)
  tot=ut.trim(oldtot)
  If totfmt="" Then totfmt=totfmt2
  If tot <> "" AND totfmt <> "" Then
    oldtot=ut.strip(oldtot,"/-() ")
		Select totfmt
			Case "1","2","3","4","5","6","7","8","9","0"
				tot = Format(tot,FormatLetter & totfmt) 
			Case "cy-m-d" 
				If StrLength(oldtot)=8 Then
					tot=StrInsert(oldtot,6,"-")
					tot=StrInsert(tot,4,"-")
				End If
			Case "cy-m" 
				If StrLength(oldtot)>=6 Then
					tot=StrInsert(oldtot,4,"-")
					tot=ut.left(tot,7)
				End If
			Case "phone" 
				If StrLength(oldtot)=10 Then
					tot=StrInsert(oldtot,6,"-")
					tot=StrInsert(tot,3,"-")
				End If
			Case "sin" 
				If StrLength(oldtot)>=7 Then
					tot=StrInsert(oldtot,6,"-")
					tot=StrInsert(tot,3,"-")
				End If
			Case "CAPS":    tot=StrToUpper(tot)
			Case "nocaps":  tot=StrToLower(tot)
			Case "Proper":  tot=ut.ProperCase(tot)
    End Select
  End If
  Return tot
End Sub

Public Sub Change(strg, StartIndex, Count, Value)
  ErrorLabel(ChangeErrorHandler)
  strg=StrRemove(strg, StartIndex, Count)
  Return StrInsert(Strg, StartIndex, Value)
	ChangeErrorHandler:	
	Return strg
End Sub

Public Sub ProperCase(s)
  If s="" Then Return ""
	s=rtrim(s)
  sz=StrLength(s)
  s=" " & StrToLower(s) & " "
  s2=""
  caps=False
  For i=0 To sz
    s1=mid(s,i,1)
    If caps=True Then s1=StrToUpper(s1)
    s2=s2 & s1
    If s1=" " OR s1="'" OR s1="," OR s1="." OR s1="(" OR s1=")" OR s1="-" OR s1="\t" Then
      caps=True
      s3=ut.mid(s,i,3)
	    s3=ut.Change(s3, 1, 1, "X")
      s4=ut.mid(s,i,4)
      s4=ut.Change(s4, 1, 2, "XX")
      If s3=" X " OR s4=" XX " Then caps=False
    Else
      caps=False
    End If
  Next
  Return trim(s2)
End Sub